Attribute VB_Name = "CommonFunctions"

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Benjamin Wilger

Option Explicit
'Hier sind ein paar ntzliche Funktionen drinne

Private Declare Function OleTranslateColor Lib "oleaut32.dll" (ByVal lOleColor As Long, ByVal lHPalette As Long, ByRef lColorRef As Long) As Long
Private Declare Function CreateSolidBrush Lib "gdi32" (ByVal crColor As Long) As Long
Private Declare Function FillRect Lib "user32" (ByVal hDC As Long, lpRect As RECT, ByVal hBrush As Long) As Long
Private Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function SetRect Lib "user32" (lpRect As RECT, ByVal X1 As Long, ByVal Y1 As Long, ByVal X2 As Long, ByVal Y2 As Long) As Long

Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWnd As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function ReleaseCapture Lib "user32" () As Long
Public Const WM_NCLBUTTONDOWN = &HA1
Public Const HTCAPTION = 2

Public Declare Function SetWindowPos Lib "user32" (ByVal hWnd As Long, ByVal hWndInsertAfter As Long, ByVal X As Long, ByVal Y As Long, ByVal cX As Long, ByVal cY As Long, ByVal wFlags As Long) As Long
Public Const SWP_NOMOVE = 2
Public Const SWP_NOSIZE = 1
Public Const SWP_NOZORDER = &H4
Public Const SWP_FLAGS = SWP_NOMOVE Or SWP_NOSIZE
Public Const HWND_TOPMOST = -1
Public Const HWND_NOTOPMOST = -2

Public Type RECT
    Left As Long
    Top As Long
    Right As Long
    Bottom As Long
End Type
Public Function DrawRECT(ByVal hDC As Long, DRect As RECT, Optional Color As Long, Optional customBrush As Long) As Long

'Zeichnet ein mit einer bestimmten Farbe geflltes Rechteck aus.
'Optional kann ein benutzerdefinierter Pinsel angegeben werden.

    Dim rBrush As Long
    If customBrush = 0 Then
        rBrush = CreateSolidBrush(Color)
    Else
        rBrush = customBrush
    End If

    DrawRECT = FillRect(hDC, DRect, rBrush)
    If customBrush = 0 Then DeleteObject rBrush
    
End Function
Public Function Sys2RGB(ByVal RGBCol As Long) As Long

'Wandelt eine Systemfarbe(z.B. vbButtonFace) in einen lesbaren RGB-Wert um

    If RGBCol < 0 Then
        OleTranslateColor RGBCol, 0&, Sys2RGB
    Else
        Sys2RGB = RGBCol
    End If
    
End Function
Public Function getRedVal(ByVal RGBCol As Long) As Integer

'Gibt den Rotanteil zurck. Wandelt ggf. Systemfarben um.

    If RGBCol < 0 Then RGBCol = Sys2RGB(RGBCol)
    If RGBCol < 0 Then RGBCol = 0
    
    '1. Bits sind gebraucht
    '00000000 00000000 11111111
                      '^^^^^^^^
                      
    getRedVal = RGBCol And &HFF
    
End Function
Public Function getGreenVal(ByVal RGBCol As Long) As Integer

'Gibt den Grnanteil zurck. Wandelt ggf. Systemfarben um.

    If RGBCol < 0 Then RGBCol = Sys2RGB(RGBCol)
    If RGBCol < 0 Then RGBCol = 0

    '2. Bits sind gebraucht
    '00000000 11111111 00000000
             '^^^^^^^^
             
    getGreenVal = ((RGBCol And &H100FF00) / &H100)
    
End Function
Public Function getBlueVal(ByVal RGBCol As Long) As Integer

'Gibt den Blauanteil zurck. Wandelt ggf. Systemfarben um.

    If RGBCol < 0 Then RGBCol = Sys2RGB(RGBCol)
    If RGBCol < 0 Then RGBCol = 0

    '3. Bits sind gebraucht
    '11111111 00000000 00000000
    '^^^^^^^^
    
    getBlueVal = (RGBCol And &HFF0000) / &H10000
    
End Function
Public Function setRange(ByVal num As Long, ByVal Min As Long, ByVal Max As Long) As Long

'Sorgt dafr, das num zwischen min und max liegt

    If num > Max Then
        num = Max
    ElseIf num < Min Then
        num = Min
    End If
    setRange = num

End Function
Public Function getMaxValue(ParamArray n()) As Long

'Gibt den grten Wert der angegebenen Parameter zurck

    Dim i As Integer, MaxVal
    
    For i = 0 To UBound(n)
        If n(i) > MaxVal Then MaxVal = n(i)
    Next i

    getMaxValue = MaxVal
    
End Function
Public Function getMinValue(ParamArray n()) As Long

'Gibt den kleinsten Wert der angegebenen Parameter zurck

    Dim i As Integer, MinVal
    
    MinVal = n(0)
    
    For i = 0 To UBound(n)
        If n(i) < MinVal Then MinVal = n(i)
    Next i

    getMinValue = MinVal
    
End Function
Public Function getGrayVal(RGBCol As Long) As Byte
    Dim R As Byte, G As Byte, B As Byte
    
'Gibt die angegebene Farbe in Graustufen wieder.
'Standardmig wird dafr der ITU-Standard
'benutzt. Es steht aber auch die CIE-LUV Variante zur Verfgung.
'Beide passen die RGB-Werte mehr dem Helligkeitsempfinden
'des Menschen an, wobei ITU Grntne strenger bewertet als der vom CIE.
    
    R = getRedVal(RGBCol)
    G = getGreenVal(RGBCol)
    B = getBlueVal(RGBCol)
    
'    'CIE-Standard:
'    'Rot:   29,89%
'    'Grn:  58,66%
'    'Blau:  11,45%
'    getGrayVal = (tRGBCol.r * 0.2989 + tRGBCol.g * 0.5866 + tRGBCol.b * 0.1145)

    'ITU Standard:
    'Rot:   22.2%
    'Grn:  70.7%
    'Blau:   7.1%
    getGrayVal = (R * 0.222 + G * 0.707 + B * 0.071)
        
End Function

